package minishell;
import java.lang.reflect.*;
import java.io.PrintStream;

public class SetField
{
    public SetField(String var, String value) throws Exception
    {
        int p = var.lastIndexOf(".");
        if (p == -1) 
	    throw new Exception("Misformed field name " + var);

	String cname = var.substring(0, p);
	String fname = var.substring(p+1);

	// System.out.println("k = " + var + " v = " + value);
	// System.out.println("c = " + cname + " f = " + fname);

	Field f = Class.forName(cname).getField(fname);
	if (!Modifier.isStatic(f.getModifiers()))
	    throw new Exception(var + " is not static");
	Class type = f.getType();
	Object o = null;

	if (type == Integer.TYPE)	o = new Integer(value);
	else if (type == Long.TYPE)	o = new Long(value);
	else if (type == Double.TYPE)	o = new Double(value);
	else if (type == Float.TYPE)	o = new Float(value);
	else if (type == Boolean.TYPE)	o = new Boolean(value);
	else if (type == Short.TYPE)	o = new Short(value);
	else if (type == Byte.TYPE)	o = new Byte(value);
	else if (type == Character.TYPE) o = new Character(value.charAt(0));
	else if (type == String.class)	o = value;
	else 
	    throw new Exception(type + " is not a primitive type ");
	f.set(null, o);
    }
}
